
def loadGeneData(filename):
    f = open(filename)
    genes = {}
    f.readline()    # read header
    for row in f:
        data = row.split()
        if not genes.has_key(data[0]):
            genes[data[0]] = []
        genes[data[0]].append(data[1])
    f.close()
    return genes

def loadClusterData(filename):
    f = open(filename)
    clusters = {}
    f.readline()    # read header
    for row in f:
        data = row.split()
        clusters[data[0]]=data[1].split(",")
    f.close()
    return clusters

def printRegulatoryElements(genes, clusters):

    print("gene\tRBPs\tmiRNAs")
    for (gene,ids) in genes.items():
        regs={}
        for id in ids:
            for element in clusters[id]:
                regs[element] = element[0].isupper()
        rbps=regs.values().count(True)
        mirnas=len(regs)-rbps
        print(gene + "\t" + str(rbps) + "\t" + str(mirnas))

def computeGeneRegulatoryElementCounts(genefile,clusterfile):

    genes=loadGeneData(genefile)
    clusters=loadClusterData(clusterfile)
    printRegulatoryElements(genes, clusters)
